#define RX 2
#include <LiquidCrystalRus.h>
int but =0;
byte a;
int b1=0;
int b2=0;
int b3=0;
LiquidCrystalRus lcd(12, 10, 11, 5, 4, 3, 6);
volatile byte level=255;
volatile unsigned long last, len;
byte p_level;
unsigned long p_len, p_len_prev;
struct {byte state; unsigned long TE;byte pre_count, data[8], dat_bit;} keeloq;
struct {unsigned char state, type, data[3], dat_bit;} came;
struct {byte state; byte pre_count, data[8], dat_bit;} starline;
struct {byte state; byte pre_count, hdr_count, data[7], dat_bit;} sh;
void setbit(byte *data, byte n)
{ data[n/8]|=1<<(n%8);};
//-----------------------------KEELOQ-----------------------------------------------------------------------------------
#define KL_MIN_PRE_COUNT 4
#define KL_MAX_TE 640 // 500
#define KL_MIN_TE 320 // 300
#define KL_MAX_BITS 64
void process_keeloq()
{switch(keeloq.state){
case 0:
if(p_level) break;
keeloq.state=1;
keeloq.pre_count=0;
break;
case 1: //pre+hdr
if(p_len>=KL_MIN_TE && p_len<=KL_MAX_TE) keeloq.pre_count++;
else if(!p_level && p_len>=KL_MIN_TE*10 && p_len<=KL_MAX_TE*10 && keeloq.pre_count>=KL_MIN_PRE_COUNT)
{
keeloq.TE=p_len/10;
keeloq.state=2;
keeloq.dat_bit=0;
keeloq.data[0]=0x00;
keeloq.data[1]=0x00;
keeloq.data[2]=0x00;
keeloq.data[3]=0x00;
keeloq.data[4]=0x00;
keeloq.data[5]=0x00;
keeloq.data[6]=0x00;
keeloq.data[7]=0x00;
} else {
keeloq.state=0;
break;}
break;
case 2: //dat
if(!p_level) break;
if(p_len<keeloq.TE/2 || p_len>keeloq.TE*3)
{keeloq.state=0;
break;}
if(p_len<=keeloq.TE+keeloq.TE/2) setbit(keeloq.data, keeloq.dat_bit);
if(++keeloq.dat_bit==KL_MAX_BITS) keeloq.state=100;
break;};};
//-----------------------------------END-KEELOQ-----------------------------------------------------------------



//----------------------------------------------STARLINE---------------------------------------------------------------------------------------
#define SL_MIN_PRE_COUNT 4
#define SL_MAX_PRE 1200
#define SL_MIN_PRE 800
#define SL_MAX_ZERO 350
#define SL_MIN_ZERO 100
#define SL_MAX_ONE 700
#define SL_MIN_ONE 400
#define SL_MIN_BITS 16
#define SL_MAX_BITS 64
void process_starline()
{byte b;
switch(starline.state){
case 0:
      if(p_level) break;
      starline.state=1;
      starline.pre_count=0;
      break;
    case 1: //pre
      if(p_len>=SL_MIN_PRE && p_len<=SL_MAX_PRE) starline.pre_count++;
      else if(p_len<SL_MIN_PRE && starline.pre_count>=SL_MIN_PRE_COUNT)
      {
        starline.state=2;
        starline.dat_bit=0;
        starline.data[0]=0x00;
        starline.data[1]=0x00;
        starline.data[2]=0x00;
        starline.data[3]=0x00;
        starline.data[4]=0x00;
        starline.data[5]=0x00;
        starline.data[6]=0x00;
        starline.data[7]=0x00;
      }
        else
      {
        starline.state=0;
        break;
      }
      break;
    case 2: //dat
      if(p_level) break; 
      if(p_len_prev>=SL_MIN_ONE && p_len_prev<=SL_MAX_ONE/* &&
         p_len>=SL_MIN_ONE && p_len<=SL_MAX_ONE*/) b=1;
       else
      if(p_len_prev>=SL_MIN_ZERO && p_len_prev<=SL_MAX_ZERO/* &&
         p_len>=SL_MIN_ZERO && p_len<=SL_MAX_ZERO*/) b=0;
      else
      {
        if(starline.dat_bit>=SL_MIN_BITS) starline.state=100;
          else starline.state=0;
        break;
      }
if(b) setbit(starline.data, starline.dat_bit);
if(++starline.dat_bit==SL_MAX_BITS) starline.state=100;
break;};};
//----------------------------------------------------END-STARLINE-----------------------------------------------------------------------------------------

//-----------------------------------------------------SHERKHAN--------------------------------------------------------------------------------------------------
#define SH_MIN_PRE_COUNT 3
#define SH_MAX_PRE 1650
#define SH_MIN_PRE 1420
#define SH_MAX_ZERO 959
#define SH_MIN_ZERO 640
#define SH_MAX_ONE 1380
#define SH_MIN_ONE 960
#define SH_MIN_BITS 33
#define SH_MAX_BITS 51
#define SH_MAX_HDR 1700
#define SH_MIN_HDR 1300
#define SH_MIN_HDR_COUNT 2
void process_sh()
{
  byte a,b;
  switch(sh.state)
  {
    case 0:
      if(p_level) break;
      sh.state=1;
      sh.hdr_count=0;
      sh.pre_count=0;
      break;
    case 1: //pre+hdr
      if(p_len>=SH_MIN_PRE && p_len<=SH_MAX_PRE&& !sh.hdr_count) sh.pre_count++;
      else if(p_len>SH_MIN_HDR && p_len<SH_MAX_HDR) sh.hdr_count++;
      else
      {
        if(sh.hdr_count>=SH_MIN_HDR_COUNT){
        sh.state=2;
        sh.dat_bit=0;
        sh.data[0]=0x00;
        sh.data[1]=0x00;
        sh.data[2]=0x00;
        sh.data[3]=0x00;
        sh.data[4]=0x00;
        sh.data[5]=0x00;
        sh.data[6]=0x00;
        sh.data[7]=0x00;
      }
        else
      {
        sh.state=0;
        break;
      }
      break;

    case 2: //dat
      if(p_level) break;
      
      if(p_len_prev>=SH_MIN_ONE && p_len_prev<=SH_MAX_ONE &&
         p_len>=SH_MIN_ONE && p_len<=SH_MAX_ONE) b=1;
       else
      if(p_len_prev>=SH_MIN_ZERO && p_len_prev<=SH_MAX_ZERO &&
         p_len>=SH_MIN_ZERO && p_len<=SH_MAX_ZERO) b=0;
      else
      {
        if(sh.dat_bit>=SH_MIN_BITS) sh.state=100;
          else sh.state=0;
        break;
      }
if(b) setbit(sh.data, sh.dat_bit);
if(++sh.dat_bit==SH_MAX_BITS) sh.state=100;
break;
};};};
//-------------------------------------------------END-SHERKHAN-------------------------------------------------------------------------------

void dump_hex(byte *buf, byte bits)
{ byte a;  
  for(a=0; a<(bits+7)/8; a++)
  {
    if(buf[a]<=0x0f) Serial.print('0');
    Serial.print(buf[a], HEX);
    Serial.print(" ");
 }
 Serial.println(""); 
}

void rx_int()
{
  if(level!=255) return;
  len=micros()-last;
  last=micros(); 
  if(digitalRead(RX)==HIGH) level=0;
    else level=1; 
}
//-----------------------------------SETUP---------------------------------------------------------------------------
void setup()
{ 
 attachInterrupt(0, rx_int, CHANGE); //прерывание на вход RX digi 2
 pinMode(10, OUTPUT); // TX pin
 pinMode(13, OUTPUT); // светодиод синий - питание
 pinMode(7, OUTPUT); // светодиод желтый
 pinMode(8, OUTPUT); // светодиод красный
 pinMode(9, OUTPUT); //  светодиод зеленый
  //----------тест-индикации-при-включении------------------------------------
  digitalWrite(7, HIGH); 
  digitalWrite(8, HIGH);
  digitalWrite(9, HIGH); 
  digitalWrite(13, HIGH); 
  delay(500);
  digitalWrite(7, LOW); 
  digitalWrite(8, LOW); 
  digitalWrite(9, LOW); 
 
  Serial.begin(57600); 
  while(!Serial);
  
  Serial.println(" ARDUINO TRX ");
  Serial.println("");
  digitalWrite(13, HIGH);
//---------------------Voltmetr-----------------------------
 int volt=0;
 int sensorValue = analogRead(A3); 
 if (sensorValue<1000)
{volt=9;
if (sensorValue<450)
{volt=8;
if (sensorValue<440)
{volt=7;
if (sensorValue<430)
{volt=6;
if (sensorValue<420)
{volt=5;
if (sensorValue<410)
{volt=4;
if (sensorValue<400)
{volt=3;
if (sensorValue<390)
{volt=2;
if (sensorValue<380)
{volt=1;
if (sensorValue<370){
volt=0;
};};};};};};};};};}; 
  lcd.begin(16, 2);
  lcd.setCursor(2, 0);
  lcd.print("ARDUINO TRX");  
  lcd.setCursor(15, 0);
  lcd.print(volt);  
//---------------------end-Voltmetr-----------------------------
  lcd.setCursor(3, 1);
  lcd.print("I'M READY"); 
  b1=1;
  interrupts();
}; 



void loop()
{ 

 //-------------------read-button----------------------------------------
// if(digitalRead(10)==HIGH) b1=0; else b1=1; //digital read
// b1 = analogRead(A0);  // analog read
// b2 = analogRead(A1); 
// b3 = analogRead(A2); 
// lcd.setCursor(12,0);
// lcd.print(b1);  

if(analogRead(A0)>1000) 
{
lcd.setCursor(14,0);
lcd.print("RX");
b1=1;
lcd.clear();
  lcd.setCursor(2, 0);
  lcd.print("ARDUINO TRX");  
  lcd.setCursor(14, 0);
  lcd.print("RX"); 
  lcd.setCursor(3, 1);
  lcd.print("I'M READY"); 
     digitalWrite(7, LOW);
     digitalWrite(8, HIGH);
} ;
if(analogRead(A1)>1000) 
{
lcd.setCursor(14,0);
lcd.print("TX");
b1=2;
b2=1;
  digitalWrite(8, LOW);
  digitalWrite(7, HIGH);
} ;
//---------------------end-read-button-------------------------------------- 

if (b1==1) {  
  if(level!=255)
  { 
    noInterrupts();
    p_level=level;
    p_len=len;
    len=0;
    level=255;
    interrupts();  
 
   process_keeloq();
   process_sh();
   process_starline(); 
   p_len_prev=p_len;
  }; 
//---------------------------KEELOQ------------------------------------------------------------
if(keeloq.state==100)
  {
 digitalWrite(9, HIGH); 
Serial.print("KEELOQ: ");
dump_hex(keeloq.data, 64);
Serial.print(keeloq.data[7], HEX);
Serial.print(keeloq.data[6], HEX);
Serial.print(keeloq.data[5], HEX);
Serial.print(keeloq.data[4], HEX);
Serial.print(keeloq.data[3], HEX);
Serial.print(keeloq.data[2], HEX);
Serial.print(keeloq.data[1], HEX);
Serial.println(keeloq.data[0], HEX);
  
lcd.clear();
lcd.setCursor(0, 0);
lcd.print("KEELOQ:");
lcd.setCursor(0, 1);
lcd.print(keeloq.data[0], HEX);
lcd.print(keeloq.data[1], HEX);
lcd.print(keeloq.data[2], HEX);
lcd.print(keeloq.data[3], HEX);
lcd.print(keeloq.data[4], HEX);
lcd.print(keeloq.data[5], HEX);
lcd.print(keeloq.data[6], HEX);
lcd.print(keeloq.data[7], HEX);  
 digitalWrite(9, LOW); 
 keeloq.state=0; 
  };
//--------------------------END-KEELOQ------------------------------------------------------------

//-----------------------------STARLINE-------------------------------------------------------------------------
if(starline.state==100)
  {
digitalWrite(9, HIGH);  
Serial.print("STARLINE[");
Serial.print(starline.dat_bit);
Serial.print("]: ");
dump_hex(starline.data, starline.dat_bit);
starline.state=0;
lcd.clear();
lcd.setCursor(0, 0);
lcd.print("STARLINE:");
lcd.setCursor(0, 1);
lcd.print(starline.data[0], HEX);
lcd.print(starline.data[1], HEX);
lcd.print(starline.data[2], HEX);
lcd.print(starline.data[3], HEX);
lcd.print(starline.data[4], HEX);
lcd.print(starline.data[5], HEX);
lcd.print(starline.data[6], HEX);
lcd.print(starline.data[7], HEX);
digitalWrite(9, LOW);        
 };
//----------------------------END-STARLINE-------------------------------------------------------------------------
//-----------------------------SHER-KHAN------------------------------------------------------------------------------------
 if(sh.state==100)
  { 
 digitalWrite(9, HIGH);         
 Serial.print("Sh[");
 Serial.print(sh.dat_bit);     
 Serial.print("]: ");
 dump_hex(sh.data, sh.dat_bit);
 sh.state=0;
lcd.clear();
lcd.setCursor(0, 0);
lcd.print("SHERKHAN:");
lcd.setCursor(0, 1);
lcd.print(sh.data[0], HEX);
lcd.print(sh.data[1], HEX);
lcd.print(sh.data[2], HEX);
lcd.print(sh.data[3], HEX);
lcd.print(sh.data[4], HEX);
lcd.print(sh.data[5], DEC);
lcd.print(sh.data[6], DEC);
lcd.print(sh.data[7], DEC);
digitalWrite(9, LOW); 
 };
//-----------------------END-SHER-KHAN-------------------------------------------------------------------------------------------------------

};//------------------------------------------MENU- end if b1 = 1 -------------------------------------

if (b1==2){
 digitalWrite(10, HIGH); 
if (b2==1){
  b2=2;
  //---------------------Voltmetr-----------------------------
 int volt=0;
 int sensorValue = analogRead(A3); 
 if (sensorValue<1000)
{volt=9;
if (sensorValue<450)
{volt=8;
if (sensorValue<440)
{volt=7;
if (sensorValue<430)
{volt=6;
if (sensorValue<420)
{volt=5;
if (sensorValue<410)
{volt=4;
if (sensorValue<400)
{volt=3;
if (sensorValue<390)
{volt=2;
if (sensorValue<380)
{volt=1;
if (sensorValue<370){
volt=0;
};};};};};};};};};}; 
//---------------------end-Voltmetr-----------------------------
lcd.clear();
lcd.setCursor(0, 0);
lcd.print("TRANSMIT");  
lcd.setCursor(15, 0);
lcd.print(volt);  
lcd.setCursor(0, 1);
lcd.print("NOICE"); 
};
delay(1);
digitalWrite(10, LOW);
delay(1);
  };

};
